import java.util.* ;

class BinTree {

    BinTree () {
	;
    }

    final static BinTree leaf = new BinTree () ;
    
    public void print () {
	;
    }
}

class Node extends BinTree {
    private BinTree left, right ;
    
    Node (BinTree left, BinTree right) {
	this.left = left;
	this.right = right ;
    }

    public void print () {
	System.out.print("(") ;
	left.print() ;
	System.out.print(")") ;
	right.print() ;
    }
}

interface Continuation {
    public void apply (BinTree t) ;
}

class PrintBinTree implements Continuation {
    public void apply (BinTree t) {
	t.print() ;
	System.out.println() ;
    }
}


class EnumC0 implements Continuation {
    private BinTree l ;
    private Continuation print;
	
    EnumC0(BinTree l, Continuation print) {
	this.l = l ;
	this.print = print ;
    }

    public void apply (BinTree r) {
	print.apply(new Node(l,r)) ;
    }
}

interface EnumI {
    public void apply (Continuation print, int n) ;
}

class EnumC1 implements Continuation {
    private EnumI enum ;
    private Continuation print;
    private int pn ;

    EnumC1(EnumI enum, Continuation print, int pn) {
	this.enum = enum ;
	this.pn = pn ;
	this.print = print ;
    }

    public void apply (BinTree l) {
	enum.apply(new EnumC0(l,print),pn) ;
    }
}


class EnumLT implements EnumI {
    EnumI enum ;

    EnumLT(EnumI enum) {
	this.enum = enum ;
    }

    public void apply (Continuation print, int n) {
	int i ;
	for (i=n-1; i>= 0; i--) {
	    enum.apply(print,i) ;
        }
    }
}

class Enum implements EnumI {
    EnumI enum_lt ;

    Enum() {
	enum_lt = new EnumLT(this) ;
    }

    public void apply (Continuation print, int n) {
	int pn = n-1 ;

	if (n==0) {
	    print.apply(BinTree.leaf) ;
        } else {
	    this.apply(new EnumC1(this,print,pn),pn) ;
	    this.apply(new EnumC1(enum_lt,print,pn),pn) ;
	    enum_lt.apply(new EnumC1(this,print,pn),pn) ;
        }
    }
}

public class EnumBT {
    public static void main (String [] args) {
	Enum enum = new Enum () ;
	enum.apply(new PrintBinTree(),3) ; 
    }
}
