type __ = Obj.t

type nat =
  | O
  | S of nat

(** val le_lt_dec : nat -> nat -> bool **)

let rec le_lt_dec n m =
  match n with
    | O -> true
    | S n0 -> (match m with
                 | O -> false
                 | S m0 -> le_lt_dec n0 m0)

(** val le_gt_dec : nat -> nat -> bool **)

let le_gt_dec n m =
  le_lt_dec n m

type 'a dS =
  | Build_DS

type 'a extractInfo =
  'a
  (* singleton inductive, whose constructor was Build_extractInfo *)

type 'a impl = __ -> 'a extractInfo

(** val pred_impl : nat -> nat extractInfo **)

let pred_impl = function
  | O -> assert false (* absurd case *)
  | S n0 -> n0

(** val minus_impl : nat -> nat -> nat extractInfo **)

let rec minus_impl n = function
  | O -> n
  | S n0 -> minus_impl (pred_impl n) n0

(** val div_impl : nat -> nat -> nat extractInfo **)

let rec div_impl a b =
  match le_gt_dec b a with
    | true -> S (div_impl (minus_impl a b) b)
    | false -> O

