(* ocamlopt enumBT.ml nums.cmxa unix.cmxa -o enumBT *)

(*
#load "nums.cma" ;;
#load "unix.cma";;
*)

open Big_int ;;
open Unix ;;

type nat = O | S of nat ;;
let rec peano n = 
  if n=0 then O else S (peano (n-1)) ;;

type bintree = Leaf | Node of  bintree*bintree ;;

let rec enumBT n f = match n with
  | O -> f Leaf
  | (S p) -> enumBT p (fun l -> enumBT p (fun r -> f (Node (l,r)))  ;
                                enumlt p (fun r -> f (Node (l,r)) ; 
                                                   f (Node (r,l))))
and enumlt n f = match n with
  | O -> ()
  | (S p) -> enumBT p f ; enumlt p f ;;


(*
let rec num2 h = match h with
  | O -> (unit_big_int, zero_big_int)
  | S h1 ->
         let (nh1,nlh1) = (num2 h1) in
         let nlh = (add_big_int nh1 nlh1) in
            (mult_big_int nh1 (add_big_int nlh nlh1),nlh);;

let numBT n = fst (num2 (peano n)) ;; 

let incr r = 
  r:=(succ_big_int (!r)); 
  if (sign_big_int (mod_big_int (!r) (big_int_of_int 1000000000)))=0 then
    ( Printf.printf "#%s" (string_of_big_int !r) ;
      print_newline() )
;;

let compte n = 
  let r = ref zero_big_int in
    enumBT (peano n) (fun t -> incr r) ;
    !r ;;

nice 20 ;;

let teste n = 
  let att = numBT n in 
    Printf.printf "attend %s" (string_of_big_int att) ;
    print_newline() ;
    let k = gettimeofday () in
    let trouv = compte n in
    let nk = gettimeofday () -. k in
      Printf.printf "trouve %s %s en %f sec\n" 
          (string_of_big_int trouv)
          (if (eq_big_int att trouv) then "OK" else "KO") 
          nk ;;

teste 7 ;; (* attend 44127887745696109598901 *)
*)

let rec print_tree t =
  match t with
  | Leaf -> print_string "@"
  | Node(Leaf,Leaf) ->
      print_string "$"
  | Node(l,Leaf) ->
      print_string "{" ;
      print_tree l ;
      print_string "}" ;
  | Node(Leaf,r) ->
      print_string "[" ;
      print_tree r ;
      print_string "]" ;
  | Node(l,r) ->
      print_string "(" ;
      print_tree l ;
      print_string "," ;
      print_tree r ;
      print_string ")" ;;

let affiche n = 
  enumBT (peano n) (fun t -> print_tree t; print_newline ()) ;;

