#use "f91.ml";;

let rec pos_of_int n =
  if n=1 then XH
  else if n mod 2 = 0 then
         XO (pos_of_int (n / 2))
  else XI (pos_of_int (n/2)) ;;

let rec int_of_pos p =
  match p with
    | XH -> 1
    | XI p -> 2 * (int_of_pos p)+1
    | XO p -> 2 * (int_of_pos p);;

let int_of_z z =
  match z with
    | Z0 -> 0
    | Zpos p -> int_of_pos p
    | Zneg p -> - (int_of_pos p) ;;

let z_of_int z =
  if z=0 then Z0 
  else if z > 0 then Zpos (pos_of_int z) 
  else Zneg (pos_of_int z);;

let f91 z = int_of_z (f91_impl (z_of_int z));;
