Require Import Tarski.

Definition glb (F: Prop->Prop) : Prop := forall p:Prop,(F p) -> p. 

Lemma inf_semilattice_Prop:
  inf_semilattice (fun (p1 p2:Prop) => p1 -> p2) glb.
Proof.
  constructor 1.
  constructor 1.
  unfold Relation_Definitions.reflexive; auto.
  unfold Relation_Definitions.transitive; eauto.
  constructor 1; unfold glb; firstorder.
Qed.

Definition lub (F: Prop->Prop) : Prop := exists p:Prop,(F p) /\ p. 

Lemma sup_semilattice_Prop: sup_semilattice (fun (p1 p2:Prop) => p1 -> p2) lub.
Proof.
  constructor 1.
  constructor 1.
  unfold Relation_Definitions.reflexive; auto.
  unfold Relation_Definitions.transitive; eauto.
  constructor 1; unfold lub; firstorder.
Qed.

Variable B: Type.

Definition glb2 (F: (B->Prop)->Prop) (x:B) : Prop := 
 forall p:B->Prop,(F p) -> (p x).

Lemma inf_semilattice_Pred:
  is_glb (fun (p1 p2:B->Prop) => forall x, (p1 x) -> (p2 x)) glb2.
Proof.
  constructor 1; unfold glb2; firstorder.
Qed.
