Set Implicit Arguments.

Section ITER.

Variable A:Type.

Fixpoint iter (n:nat) (f: A->A) (x:A) { struct n }: A :=
  match n with
  | O => x
  | (S n) => (f (iter n f x))
  end.

Lemma iter_succ: forall (n:nat) (f: A->A) (x:A), (iter n f (f x))=(f (iter n f x)).
Proof.
 induction n; simpl; auto.
 intros; rewrite IHn.
 auto.
Qed.

Lemma iter_plus: forall (n m:nat) (f: A->A) (x:A), (iter n f (iter m f x))=(iter (n+m) f x).
Proof.
 induction n; simpl; auto.
 intros; rewrite IHn.
 auto.
Qed.

Lemma iter_mult: forall (n m:nat) (f: A->A) (x:A), (iter n (iter m f) x)=(iter (n*m) f x).
Proof.
 induction n; simpl; auto.
 intros; rewrite IHn.
 rewrite iter_plus; auto.
Qed.

End ITER.

Unset Implicit Arguments.
