Set Implicit Arguments.

Inductive NonEmpty (A:Type) : Prop :=
  | witness: A -> (NonEmpty A).

Hint Resolve witness: nonempty.

Lemma nat_NonEmpty: (NonEmpty nat).
Proof (witness O).

Lemma bool_NonEmpty: (NonEmpty bool).
Proof (witness true).

Lemma prod_NonEmpty: forall (A B:Type),
  (NonEmpty A)->(NonEmpty B)->(NonEmpty (prodT A B)).
Proof.
  intros A B H1 H2; case H1; case H2.
  intros; apply witness.
  constructor 1; auto.
Qed.

Require Import ZArith.
Lemma Z_NonEmpty: (NonEmpty Z).
Proof (witness ((0)%Z)).

Hint Resolve nat_NonEmpty bool_NonEmpty prod_NonEmpty Z_NonEmpty: nonempty.

Unset Implicit Arguments.
