#!/bin/bash
#
# FICHIER qui adapte le comportement de "coqdoc --html"
# a ma convenance... (modification du source ".v") en entree
#
# L'entree doit avoir la forme "coqdoc -html fich1.v [...]" 
# sinon, on utilise "coqdoc"
#
# DOCDEBUG: variable de debogguage

coqdoc=/usr/bin/coqdoc
suffixe=`echo $2 | sed -e "s/.*\.v$/1/g" -e "s/.*[^1].*/0/g"`

if [ $DOCDEBUG ]; then
  echo "DOCDEBUG valeur suffixe pour $2: " $suffixe
fi

if [[ $1 != "-html" || $suffixe != "1" ]]; then
    if [ $DOCDEBUG ]; then
	echo "DOCDEBUG: appel standard a coqdoc" 
    fi
    ${coqdoc} $@
    exit 0
fi

mv -f $2 $2.xbak

cat $2.xbak | grep -v "begin hide" | grep -v "end hide" > $2

if [ $DOCDEBUG ]; then
    echo "DOCDEBUG: on lance coqdoc sur le fichier suivant"
    cat $2
    echo "DOCDEBUG: **************************************"
fi

echo "patch applied..."
${coqdoc} $@

mv -f $2.xbak $2
exit 0